# -*- coding: utf-8 -*-
# Generated by Django 1.9.13 on 2018-01-25 09:06
from __future__ import unicode_literals

from django.db import migrations, models

from beat.backend.python.hash import hashDataset


def compute_hashes(apps, schema_editor):
    '''Refreshes each database so datasets/outputs are recreated'''

    DatabaseSet = apps.get_model("databases", "DatabaseSet")

    if DatabaseSet.objects.count():
        print('')

    for db_set in DatabaseSet.objects.order_by('id'):
        print("Computing hashes for database set '%s/%d/%s/%s'..." % \
                (db_set.protocol.database.name, db_set.protocol.database.version,
                 db_set.protocol.name, db_set.name))

        db_set.hash = hashDataset('%s/%d' % (db_set.protocol.database.name, db_set.protocol.database.version),
                                  db_set.protocol.name, db_set.name)
        db_set.save()


class Migration(migrations.Migration):

    dependencies = [
        ('databases', '0003_auto_20160704_1316'),
    ]

    operations = [
        migrations.RemoveField(
            model_name='databasesetoutput',
            name='hash',
        ),
        migrations.AddField(
            model_name='databaseset',
            name='hash',
            field=models.CharField(default='', max_length=64),
            preserve_default=False,
        ),
        migrations.RunPython(compute_hashes),
        migrations.AlterField(
            model_name='databaseset',
            name='hash',
            field=models.CharField(max_length=64, unique=True),
            preserve_default=False,
        ),
    ]
